# Copyright 2021 Christian Ulrich
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# usage: ./part1 < input

import strutils

proc countIncreases(): uint =
  var
    line = ""
    prevDepth = high(uint)
  while readLine(stdin, line):
    if line.len() > 0:
      let depth = parseUint(line)
      if depth > prevDepth:
        result.inc()
      prevDepth = depth

proc main(): int =
  try:
    echo countIncreases()
  except ValueError:
    result = -1

when isMainModule:
  quit(main())
