# Copyright 2021 Christian Ulrich
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# usage: ./part2 < input

import strutils

proc position(): int =
  var
    line = ""
    aim = 0
    hpos = 0
    vpos = 0
  while readLine(stdin, line):
    if line.len() > 0:
      let command = line.split(' ', 1)
      if command.len() != 2:
        raise newException(ValueError, "invalid command")
      let arg = parseInt(command[1])
      case command[0]
      of "forward":
        hpos.inc(arg)
        vpos.inc(aim * arg)
      of "up":
        aim.dec(arg)
      of "down":
        aim.inc(arg)
      else:
        raise newException(ValueError, "invalid command")
  result = hpos * vpos

proc main(): int =
  try:
    echo position()
  except Exception as error:
    echo error.msg
    result = -1

when isMainModule:
  quit(main())
