# Copyright 2021 Christian Ulrich
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# usage: ./part1 < input

import sequtils
import strutils

const Days = 80

proc predictLanternfishCount(): int =
  var
    timers = readLine(stdin).split(',').mapIt(uint8(parseUint(it)))
    newTimers: seq[uint8]
  for day in 0 ..< Days:
    newTimers.setLen(0)
    for timer in timers.mitems():
      if timer == 0'u8:
        newTimers.add(8'u8)
        timer = 6'u8
      else:
        timer.dec()
    timers.add(newTimers)
  result = timers.len()

proc main(): int =
  try:
    echo predictLanternfishCount()
  except Exception as error:
    echo error.msg
    result = -1

when isMainModule:
  quit(main())
