# Copyright 2021 Christian Ulrich
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# usage: ./part1 < input

import sequtils
import strutils

proc distance(a, b: int16): int =
  let linearDistance = int(abs(b - a))
  # 1 + 2 + 3 + ... + n - 1 is the binomial coefficient (n over k) with k = 2
  result = (linearDistance + 1) * linearDistance div 2

proc minimizeFuel(): int =
  let crabs = readLine(stdin).split(',').mapIt(int16(parseUint(it)))
  result = high(int)
  for pos in crabs.min() .. crabs.max():
    result = min(result, crabs.foldl(a + distance(b, pos), 0))

proc main(): int =
  try:
    echo minimizeFuel()
  except Exception as error:
    echo error.msg
    result = -1

when isMainModule:
  quit(main())
